import{s as Ve,n as ze,o as Ae}from"../chunks/scheduler.8c3d61f6.js";import{S as Ne,i as Ue,g as d,s as r,r as u,A as Fe,h as c,f as s,c as n,j as S,u as p,x as m,k as x,y as t,a as l,v as f,d as h,t as g,w as _}from"../chunks/index.589a98e8.js";import{D as A}from"../chunks/Docstring.27406313.js";import{H as He,E as je}from"../chunks/EditOnGithub.e5a8d9cb.js";function Ke(Me){let b,Q,B,X,y,Y,w,Te='<code>LMSDiscreteScheduler</code> is a linear multistep scheduler for discrete beta schedules. The scheduler is ported from and created by <a href="https://github.com/crowsonkb/" rel="nofollow">Katherine Crowson</a>, and the original implementation can be found at <a href="https://github.com/crowsonkb/k-diffusion/blob/481677d114f6ea445aa009cf5bd7a9cdee909e47/k_diffusion/sampling.py#L181" rel="nofollow">crowsonkb/k-diffusion</a>.',Z,C,ee,o,P,pe,N,ye="A linear multistep scheduler for discrete beta schedules.",me,U,we=`This model inherits from <a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/main/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. Check the superclass documentation for the generic
methods the library implements for all schedulers such as loading and saving.`,fe,$,k,he,F,Ce="Compute the linear multistep coefficient.",ge,D,O,_e,j,Pe=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`,be,L,E,ve,K,ke="Sets the begin index for the scheduler. This function should be run from pipeline before the inference.",Se,M,I,xe,R,Oe="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",$e,T,q,De,W,Ee=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the diffusion
process from the learned model outputs (most often the predicted noise).`,te,H,Ie="## LMSDiscreteSchedulerOutput[[diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteSchedulerOutput]]",se,v,V,Le,G,qe="Output class for the scheduler’s <code>step</code> function output.",re,z,ne,J,oe;return y=new He({props:{title:"LMSDiscreteScheduler",local:"lmsdiscretescheduler",headingTag:"h1"}}),C=new He({props:{title:"LMSDiscreteScheduler",local:"diffusers.LMSDiscreteScheduler",headingTag:"h2"}}),P=new A({props:{name:"class diffusers.LMSDiscreteScheduler",anchor:"diffusers.LMSDiscreteScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.0001"},{name:"beta_end",val:": float = 0.02"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": Union = None"},{name:"use_karras_sigmas",val:": Optional = False"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"timestep_spacing",val:": str = 'linspace'"},{name:"steps_offset",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.LMSDiscreteScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.LMSDiscreteScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.0001) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.LMSDiscreteScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.02) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.LMSDiscreteScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code> or <code>scaled_linear</code>.`,name:"beta_schedule"},{anchor:"diffusers.LMSDiscreteScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, <em>optional</em>) &#x2014;
Pass an array of betas directly to the constructor to bypass <code>beta_start</code> and <code>beta_end</code>.`,name:"trained_betas"},{anchor:"diffusers.LMSDiscreteScheduler.use_karras_sigmas",description:`<strong>use_karras_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use Karras sigmas for step sizes in the noise schedule during the sampling process. If <code>True</code>,
the sigmas are determined according to a sequence of noise levels {&#x3C3;i}.`,name:"use_karras_sigmas"},{anchor:"diffusers.LMSDiscreteScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.LMSDiscreteScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;linspace&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.LMSDiscreteScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps, as required by some model families.`,name:"steps_offset"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_lms_discrete.py#L92"}}),k=new A({props:{name:"get_lms_coefficient",anchor:"diffusers.LMSDiscreteScheduler.get_lms_coefficient",parameters:[{name:"order",val:""},{name:"t",val:""},{name:"current_order",val:""}],parametersDescription:[{anchor:"diffusers.LMSDiscreteScheduler.get_lms_coefficient.order",description:"<strong>order</strong> () &#x2014;",name:"order"},{anchor:"diffusers.LMSDiscreteScheduler.get_lms_coefficient.t",description:"<strong>t</strong> () &#x2014;",name:"t"},{anchor:"diffusers.LMSDiscreteScheduler.get_lms_coefficient.current_order",description:"<strong>current_order</strong> () &#x2014;",name:"current_order"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_lms_discrete.py#L229"}}),O=new A({props:{name:"scale_model_input",anchor:"diffusers.LMSDiscreteScheduler.scale_model_input",parameters:[{name:"sample",val:": Tensor"},{name:"timestep",val:": Union"}],parametersDescription:[{anchor:"diffusers.LMSDiscreteScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
The input sample.`,name:"sample"},{anchor:"diffusers.LMSDiscreteScheduler.scale_model_input.timestep",description:`<strong>timestep</strong> (<code>float</code> or <code>torch.Tensor</code>) &#x2014;
The current timestep in the diffusion chain.`,name:"timestep"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_lms_discrete.py#L205",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A scaled input sample.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),E=new A({props:{name:"set_begin_index",anchor:"diffusers.LMSDiscreteScheduler.set_begin_index",parameters:[{name:"begin_index",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.LMSDiscreteScheduler.set_begin_index.begin_index",description:`<strong>begin_index</strong> (<code>int</code>) &#x2014;
The begin index for the scheduler.`,name:"begin_index"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_lms_discrete.py#L195"}}),I=new A({props:{name:"set_timesteps",anchor:"diffusers.LMSDiscreteScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": int"},{name:"device",val:": Union = None"}],parametersDescription:[{anchor:"diffusers.LMSDiscreteScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model.`,name:"num_inference_steps"},{anchor:"diffusers.LMSDiscreteScheduler.set_timesteps.device",description:`<strong>device</strong> (<code>str</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The device to which the timesteps should be moved to. If <code>None</code>, the timesteps are not moved.`,name:"device"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_lms_discrete.py#L251"}}),q=new A({props:{name:"step",anchor:"diffusers.LMSDiscreteScheduler.step",parameters:[{name:"model_output",val:": Tensor"},{name:"timestep",val:": Union"},{name:"sample",val:": Tensor"},{name:"order",val:": int = 4"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.LMSDiscreteScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.Tensor</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.LMSDiscreteScheduler.step.timestep",description:`<strong>timestep</strong> (<code>float</code> or <code>torch.Tensor</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.LMSDiscreteScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.LMSDiscreteScheduler.step.order",description:`<strong>order</strong> (<code>int</code>, defaults to 4) &#x2014;
The order of the linear multistep method.`,name:"order"},{anchor:"diffusers.LMSDiscreteScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/schedulers/multistep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput">SchedulerOutput</a> or tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_lms_discrete.py#L365",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>If return_dict is <code>True</code>, <a
  href="/docs/diffusers/main/en/api/schedulers/multistep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> is returned, otherwise a
tuple is returned where the first element is the sample tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><a
  href="/docs/diffusers/main/en/api/schedulers/multistep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> or <code>tuple</code></p>
`}}),V=new A({props:{name:"class diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteSchedulerOutput",anchor:"diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteSchedulerOutput",parameters:[{name:"prev_sample",val:": Tensor"},{name:"pred_original_sample",val:": Optional = None"}],parametersDescription:[{anchor:"diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteSchedulerOutput.prev_sample",description:`<strong>prev_sample</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
Computed sample <code>(x_{t-1})</code> of previous timestep. <code>prev_sample</code> should be used as next model input in the
denoising loop.`,name:"prev_sample"},{anchor:"diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteSchedulerOutput.pred_original_sample",description:`<strong>pred_original_sample</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
The predicted denoised sample <code>(x_{0})</code> based on the model output from the current timestep.
<code>pred_original_sample</code> can be used to preview progress or for guidance.`,name:"pred_original_sample"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_lms_discrete.py#L28"}}),z=new je({props:{source:"https://github.com/huggingface/diffusers/blob/main/docs/source/en/api/schedulers/lms_discrete.md"}}),{c(){b=d("meta"),Q=r(),B=d("p"),X=r(),u(y.$$.fragment),Y=r(),w=d("p"),w.innerHTML=Te,Z=r(),u(C.$$.fragment),ee=r(),o=d("div"),u(P.$$.fragment),pe=r(),N=d("p"),N.textContent=ye,me=r(),U=d("p"),U.innerHTML=we,fe=r(),$=d("div"),u(k.$$.fragment),he=r(),F=d("p"),F.textContent=Ce,ge=r(),D=d("div"),u(O.$$.fragment),_e=r(),j=d("p"),j.textContent=Pe,be=r(),L=d("div"),u(E.$$.fragment),ve=r(),K=d("p"),K.textContent=ke,Se=r(),M=d("div"),u(I.$$.fragment),xe=r(),R=d("p"),R.textContent=Oe,$e=r(),T=d("div"),u(q.$$.fragment),De=r(),W=d("p"),W.textContent=Ee,te=r(),H=d("p"),H.textContent=Ie,se=r(),v=d("div"),u(V.$$.fragment),Le=r(),G=d("p"),G.innerHTML=qe,re=r(),u(z.$$.fragment),ne=r(),J=d("p"),this.h()},l(e){const i=Fe("svelte-u9bgzb",document.head);b=c(i,"META",{name:!0,content:!0}),i.forEach(s),Q=n(e),B=c(e,"P",{}),S(B).forEach(s),X=n(e),p(y.$$.fragment,e),Y=n(e),w=c(e,"P",{"data-svelte-h":!0}),m(w)!=="svelte-1otp9cb"&&(w.innerHTML=Te),Z=n(e),p(C.$$.fragment,e),ee=n(e),o=c(e,"DIV",{class:!0});var a=S(o);p(P.$$.fragment,a),pe=n(a),N=c(a,"P",{"data-svelte-h":!0}),m(N)!=="svelte-1s0vl92"&&(N.textContent=ye),me=n(a),U=c(a,"P",{"data-svelte-h":!0}),m(U)!=="svelte-zthkot"&&(U.innerHTML=we),fe=n(a),$=c(a,"DIV",{class:!0});var ie=S($);p(k.$$.fragment,ie),he=n(ie),F=c(ie,"P",{"data-svelte-h":!0}),m(F)!=="svelte-l6j38t"&&(F.textContent=Ce),ie.forEach(s),ge=n(a),D=c(a,"DIV",{class:!0});var de=S(D);p(O.$$.fragment,de),_e=n(de),j=c(de,"P",{"data-svelte-h":!0}),m(j)!=="svelte-1rkfgpx"&&(j.textContent=Pe),de.forEach(s),be=n(a),L=c(a,"DIV",{class:!0});var ce=S(L);p(E.$$.fragment,ce),ve=n(ce),K=c(ce,"P",{"data-svelte-h":!0}),m(K)!=="svelte-1k141rk"&&(K.textContent=ke),ce.forEach(s),Se=n(a),M=c(a,"DIV",{class:!0});var ae=S(M);p(I.$$.fragment,ae),xe=n(ae),R=c(ae,"P",{"data-svelte-h":!0}),m(R)!=="svelte-1vzm9q"&&(R.textContent=Oe),ae.forEach(s),$e=n(a),T=c(a,"DIV",{class:!0});var le=S(T);p(q.$$.fragment,le),De=n(le),W=c(le,"P",{"data-svelte-h":!0}),m(W)!=="svelte-hi84tp"&&(W.textContent=Ee),le.forEach(s),a.forEach(s),te=n(e),H=c(e,"P",{"data-svelte-h":!0}),m(H)!=="svelte-1oabuta"&&(H.textContent=Ie),se=n(e),v=c(e,"DIV",{class:!0});var ue=S(v);p(V.$$.fragment,ue),Le=n(ue),G=c(ue,"P",{"data-svelte-h":!0}),m(G)!=="svelte-id9kic"&&(G.innerHTML=qe),ue.forEach(s),re=n(e),p(z.$$.fragment,e),ne=n(e),J=c(e,"P",{}),S(J).forEach(s),this.h()},h(){x(b,"name","hf:doc:metadata"),x(b,"content",Re),x($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(o,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,i){t(document.head,b),l(e,Q,i),l(e,B,i),l(e,X,i),f(y,e,i),l(e,Y,i),l(e,w,i),l(e,Z,i),f(C,e,i),l(e,ee,i),l(e,o,i),f(P,o,null),t(o,pe),t(o,N),t(o,me),t(o,U),t(o,fe),t(o,$),f(k,$,null),t($,he),t($,F),t(o,ge),t(o,D),f(O,D,null),t(D,_e),t(D,j),t(o,be),t(o,L),f(E,L,null),t(L,ve),t(L,K),t(o,Se),t(o,M),f(I,M,null),t(M,xe),t(M,R),t(o,$e),t(o,T),f(q,T,null),t(T,De),t(T,W),l(e,te,i),l(e,H,i),l(e,se,i),l(e,v,i),f(V,v,null),t(v,Le),t(v,G),l(e,re,i),f(z,e,i),l(e,ne,i),l(e,J,i),oe=!0},p:ze,i(e){oe||(h(y.$$.fragment,e),h(C.$$.fragment,e),h(P.$$.fragment,e),h(k.$$.fragment,e),h(O.$$.fragment,e),h(E.$$.fragment,e),h(I.$$.fragment,e),h(q.$$.fragment,e),h(V.$$.fragment,e),h(z.$$.fragment,e),oe=!0)},o(e){g(y.$$.fragment,e),g(C.$$.fragment,e),g(P.$$.fragment,e),g(k.$$.fragment,e),g(O.$$.fragment,e),g(E.$$.fragment,e),g(I.$$.fragment,e),g(q.$$.fragment,e),g(V.$$.fragment,e),g(z.$$.fragment,e),oe=!1},d(e){e&&(s(Q),s(B),s(X),s(Y),s(w),s(Z),s(ee),s(o),s(te),s(H),s(se),s(v),s(re),s(ne),s(J)),s(b),_(y,e),_(C,e),_(P),_(k),_(O),_(E),_(I),_(q),_(V),_(z,e)}}}const Re='{"title":"LMSDiscreteScheduler","local":"lmsdiscretescheduler","sections":[{"title":"LMSDiscreteScheduler","local":"diffusers.LMSDiscreteScheduler","sections":[],"depth":2}],"depth":1}';function We(Me){return Ae(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Xe extends Ne{constructor(b){super(),Ue(this,b,We,Ke,Ve,{})}}export{Xe as component};
